/*!
 * timon.js
 * Copyright(c) 2024 Timon Fiedler
 * MIT Licensed
 */
"use strict";let DEBUG=false;function timonjs_setDebugMode(value){DEBUG=value}function timonjs_message(){const message=(color,size,padding)=>`color:${color}; font-size:${size}em; background-color:#000; font-family:Consolas, monospace; padding:0.75em ${padding}; display:block;`;console.log("%cCustom Coded by @timon.dev",message("#0f0",2,"25%"));console.log("%cVisit https://www.timondev.com",message("#fff",1,"35%"))}function toBase64(file){return new Promise(((resolve,reject)=>{const reader=new FileReader;reader.onload=()=>resolve(reader.result);reader.onerror=reject;reader.readAsDataURL(file)}))}function toBase64Max(file,bytes,scale=.8){return new Promise(((resolve,reject)=>{const reader=new FileReader;reader.onload=()=>{const img=new Image;img.src=reader.result;img.onload=()=>{const scaleFactor=Math.min(1,bytes/file.size);const width=img.width*scaleFactor;const height=img.height*scaleFactor;const canvas=document.createElement("canvas");const ctx=canvas.getContext("2d");canvas.width=width;canvas.height=height;ctx.drawImage(img,0,0,width,height);const resizedImage=canvas.toDataURL("image/jpeg",scale);resolve(resizedImage)}};reader.onerror=reject;reader.readAsDataURL(file)}))}function toDateString(date){const monthNames=["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"];const day=date.getDate();const month=monthNames[date.getMonth()];const year=date.getFullYear();const time=date.toLocaleTimeString();return`${day}. ${month} ${year} um ${time}`}function timonjs_on(element,event,callback,...args){element.addEventListener(event,callback,...args);return element}function timonjs_off(element,event,callback,...args){element.removeEventListener(event,callback,...args);return element}function timonjs_click(element,nativeClick,callback,...args){if(typeof callback==="function"){element.addEventListener("click",callback,...args)}else{nativeClick()}return element}function timonjs_childrenOn(element,event,callback,...args){Array.from(element.children).forEach((child=>{child.addEventListener(event,callback,...args)}));return element}function timonjs_childrenOff(element,event,callback,...args){Array.from(element.children).forEach((child=>{child.removeEventListener(event,callback,...args)}));return element}function timonjs_childrenClick(element,callback,...args){if(typeof callback==="function"){Array.from(element.children).forEach((child=>{child.addEventListener("click",callback,...args)}))}else{Array.from(element.children).forEach((child=>{child.click()}))}return element}function timonjs_css(element,styles,value){if(typeof styles==="object"){Object.entries(styles).map((([property,value])=>element.style.setProperty(property,value)));Object.assign(element.style,styles)}else if(typeof styles==="string"&&typeof value==="string"){element.style[styles]=value}else if(typeof styles==="string"&&typeof value==="undefined"){return element.style[styles]}return element}function timonjs_toggle(element,type="block",type2="none"){element.style.display=element.style.display===type2?type:type2;return element}function timonjs_hide(element){element.style.display="none";return element}function timonjs_show(element,type="block"){element.style.display=type;return element}function timonjs_flex(element){element.style.display="flex";return element}function timonjs_grid(element){element.style.display="grid";return element}function timonjs_rotate(element,degrees){element.style.transform+=`rotate(${degrees}deg)`;return element}function timonjs_text(element,text){if(typeof text==="undefined"){return element.innerText}else{element.innerText=text.toString();return element}}function timonjs_html(element,html){if(typeof html==="undefined"){return element.innerHTML}else{element.innerHTML=html.toString();return element}}function timonjs_val(element,value){if(typeof value==="undefined"){return element.value}else{element.value=value;return element}}function timonjs_class(element,className,replaceClass){const toggle=name=>element.classList.toggle(name);if(typeof replaceClass==="undefined"){if(typeof className==="undefined"){return Array.from(element.classList).join(" ")}else if(Array.isArray(className)){className.forEach((name=>{toggle(name)}))}else{toggle(className)}}else{toggle(replaceClass);toggle(className)}return element}function timonjs_addClass(element,...classList){classList.forEach((name=>{element.classList.add(name)}));return element}function timonjs_removeClass(element,...classList){classList.forEach((name=>{element.classList.remove(name)}));return element}function timonjs_replaceClass(element,replaceClass,setClass){element.classList.remove(replaceClass);element.classList.add(setClass);return element}function timonjs_toggleClass(element,...classNames){classNames.forEach((className=>{element.classList.toggle(className)}));return element}function timonjs_hasClass(element,...classNames){return classNames.every((className=>element.classList.contains(className)))}function timonjs_attr(element,type,value){if(typeof value==="undefined"&&typeof type==="undefined"){const attributes={};for(const attr of element.attributes){attributes[attr.name]=attr.value}return attributes}else if(typeof value==="undefined"&&typeof type==="string"){return element.getAttribute(type)}else if(typeof type==="object"){Object.entries(type).forEach((([key,value])=>{element.setAttribute(key,value)}))}else{element.setAttribute(type,value)}return element}function timonjs_attribute(element,type,value){return timonjs_attr(element,type,value)}function timonjs_data(element,dataName,value){if(typeof value==="undefined"&&typeof dataName==="undefined"){const dataObject={};for(const attr of element.attributes){if(attr.name.startsWith("data")){dataObject[attr.name]=attr.value}}return dataObject}else if(typeof value==="undefined"&&typeof dataName==="string"){return element.getAttribute(dataName)}else if(typeof value==="string"&&typeof dataName==="string"){element.setAttribute(dataName,value)}return element}function timonjs_toggleText(element,text1,text2){if(element.innerText===text1){element.innerText=text2}else{element.innerText=text1}return element}function timonjs_toggleHTML(element,html1,html2){if(element.innerHTML===html1){element.innerHTML=html2}else{element.innerHTML=html1}return element}function timonjs_parent(element){const parent=element.parentElement;if(typeof parent.id==="string"){return document.getElementById(parent.id)}else{const id=randomString(128);parent.id=id;const parentElement=document.getElementById(id);parentElement.removeAttribute("id");return parentElement}}function hasChild(element,child){for(let i=0;i<element.children.length;i++){if(child===element.children[i])return true}return false}function hasChildWithId(element,id){const child=document.getElementById(id);for(let i=0;i<element.children.length;i++){if(child===element.children[i])return true}return false}function timonjs_x(element){return element.offsetWidth}function timonjs_y(element){return element.offsetHeight}function timonjs_xy(element){return{x:element.offsetWidth,y:element.offsetHeight}}function timonjs_customId(element,id){if(typeof id==="string"){element.timonId=id}else{return element.timonId}return element}function timonjs_timonId(element,id){return timonjs_customId(element,id)}function timonjs_append(element,...nodes){nodes.forEach((node=>{element.appendChild(node)}));return element}function timonjs_prepend(element,...nodes){nodes.forEach((node=>{element.prepend(node)}));return element}function timonjs_childrenCount(element){return element.children.length}function timonjs_file(element){if(typeof element.files[0]==="undefined"){return null}else{return element.files[0]}}function timonjs_files(element){return element.files}function timonjs_valIsEmpty(element){const value=element.value;if(value===undefined||value===null||value===""||typeof value==="undefined"){return true}else if(Array.isArray(value)&&value?.length===0){return true}else if(typeof value==="object"&&Object.keys(value)?.length===0){return true}else{return false}}function timonjs_vIE(element){return timonjs_valIsEmpty(element)}function timonjs_textIsEmpty(element){const text=element.innerText;if(text===undefined||text===null||text===""||typeof text==="undefined"){return true}else if(Array.isArray(text)&&text?.length===0){return true}else if(typeof text==="object"&&Object.keys(text)?.length===0){return true}else{return false}}function timonjs_htmlIsEmpty(element){const html=element.innerHTML;if(html===undefined||html===null||html===""||typeof html==="undefined"){return true}else if(Array.isArray(html)&&html?.length===0){return true}else if(typeof html==="object"&&Object.keys(html)?.length===0){return true}else{return false}}function timonjs_addAfter(element,...nodes){nodes.forEach((node=>{element.insertAdjacentElement(node)}));return element}function timonjs_addBefore(element,...nodes){nodes.forEach((node=>{element.parentElement.insertBefore(node,element)}));return element}function timonjs_getImg(element){if(element.tagName!=="IMG"&&element.tagName!=="CANVAS"&&!(element.tagName==="INPUT"&&element.type==="file")){throw new Error("This element does not contain an image.")}const image=new Image;if(element.tagName==="IMG"){image.src=element.src}else if(element.tagName==="INPUT"){const file=element.files[0];if(file){const reader=new FileReader;reader.onload=event=>{image.src=event.target.result};reader.readAsDataURL(file)}}else if(element.tagName==="CANVAS"){const context=element.getContext("2d");image.onload=()=>{context.drawImage(image,0,0)};image.src="image.jpg"}return image}function timonjs_getImgBase64(element){if(element.tagName!=="IMG"&&element.tagName!=="CANVAS"&&!(element.tagName==="INPUT"&&element.type==="file")){throw new Error("This element does not contain an image.")}if(element.tagName==="IMG"){const image=new Image;image.src=element.src;return new Promise(((resolve,reject)=>{image.onload=()=>{const canvas=document.createElement("canvas");const context=canvas.getContext("2d");canvas.width=image.width;canvas.height=image.height;context.drawImage(image,0,0,image.width,image.height);resolve(canvas.toDataURL("image/png"))};image.onerror=()=>{reject(new Error("Failed to load image."))}}))}else if(element.tagName==="INPUT"){const file=element.files[0];if(file){return new Promise(((resolve,reject)=>{const reader=new FileReader;reader.onload=event=>{resolve(event.target.result)};reader.onerror=()=>{reject(new Error("Failed to read file."))};reader.readAsDataURL(file)}))}}else if(element.tagName==="CANVAS"){return Promise.resolve(element.toDataURL("image/png"))}}async function timonjs_imgBase(element){return await timonjs_getImgBase64(element)}function timonjs_fullscreen(element){if(element.requestFullscreen){element.requestFullscreen()}else if(element.mozRequestFullScreen){element.mozRequestFullScreen()}else if(element.webkitRequestFullscreen){element.webkitRequestFullscreen()}else if(element.msRequestFullscreen){element.msRequestFullscreen()}}function getElm(id,caller=document){const element=caller.getElementById(id);if(element===null){console.error(`The element with id ${id} does not exist!`)}if(typeof element.timonId==="string"){return element}const settingError=name=>{if(DEBUG)console.log(`The function "${name}" is already declared for this element. The replaced function is named "_${name}".`)};element.timonId=randomString(16);const nativeClick=element.click.bind(element);try{element.on=(event,callback,...args)=>timonjs_on(element,event,callback,...args)}catch(error){settingError("on");element._on=(event,callback,...args)=>timonjs_on(element,event,callback,...args)}try{element.off=(event,callback,...args)=>timonjs_off(element,event,callback,...args)}catch(error){settingError("off");element._off=(event,callback,...args)=>timonjs_off(element,event,callback,...args)}try{element.click=(callback,...args)=>timonjs_click(element,nativeClick,callback,...args)}catch(error){settingError("click");element._click=(callback,...args)=>timonjs_click(element,nativeClick,callback,...args)}try{element.childrenOn=(event,callback,...args)=>timonjs_childrenOn(element,event,callback,...args)}catch(error){settingError("childrenOn");element._childrenOn=(event,callback,...args)=>timonjs_childrenOn(element,event,callback,...args)}try{element.childrenOff=(event,callback,...args)=>timonjs_childrenOff(element,event,callback,...args)}catch(error){settingError("childrenOff");element._childrenOff=(event,callback,...args)=>timonjs_childrenOff(element,event,callback,...args)}try{element.childrenClick=(callback,...args)=>timonjs_childrenClick(element,callback,...args)}catch(error){settingError("childrenClick");element._childrenClick=(callback,...args)=>timonjs_childrenClick(element,callback,...args)}try{element.css=(styles,value)=>timonjs_css(element,styles,value)}catch(error){settingError("css");element._css=(styles,value)=>timonjs_css(element,styles,value)}try{element.toggle=(type,type2)=>timonjs_toggle(element,type,type2)}catch(error){settingError("toggle");element._toggle=(type,type2)=>timonjs_toggle(element,type,type2)}try{element.hide=()=>timonjs_hide(element)}catch(error){settingError("hide");element._hide=()=>timonjs_hide(element)}try{element.show=type=>timonjs_show(element,type)}catch(error){settingError("show");element._show=type=>timonjs_show(element,type)}try{element.flex=()=>timonjs_flex(element)}catch(error){settingError("flex");element._flex=()=>timonjs_flex(element)}try{element.grid=()=>timonjs_grid(element)}catch(error){settingError("grid");element._grid=()=>timonjs_grid(element)}try{element.rotate=degrees=>timonjs_rotate(element,degrees)}catch(error){settingError("rotate");element._rotate=degrees=>timonjs_rotate(element,degrees)}try{if(element.text)throw new Error;element.text=text=>timonjs_text(element,text)}catch(error){settingError("text");element._text=text=>timonjs_text(element,text)}try{element.html=html=>timonjs_html(element,html)}catch(error){settingError("html");element._html=html=>timonjs_html(element,html)}try{element.val=value=>timonjs_val(element,value)}catch(error){settingError("val");element._val=value=>timonjs_val(element,value)}try{element.class=(className,replaceClass)=>timonjs_class(element,className,replaceClass)}catch(error){settingError("class");element._class=(className,replaceClass)=>timonjs_class(element,className,replaceClass)}try{element.addClass=(...classList)=>timonjs_addClass(element,...classList)}catch(error){settingError("addClass");element._addClass=(...classList)=>timonjs_addClass(element,...classList)}try{element.removeClass=(...classList)=>timonjs_removeClass(element,...classList)}catch(error){settingError("removeClass");element._removeClass=(...classList)=>timonjs_removeClass(element,...classList)}try{element.replaceClass=(replaceClass,setClass)=>timonjs_replaceClass(element,replaceClass,setClass)}catch(error){settingError("replaceClass");element._replaceClass=(replaceClass,setClass)=>timonjs_replaceClass(element,replaceClass,setClass)}try{element.toggleClass=(...classNames)=>timonjs_toggleClass(element,...classNames)}catch(error){settingError("toggleClass");element._toggleClass=(...classNames)=>timonjs_toggleClass(element,...classNames)}try{element.hasClass=(...classNames)=>timonjs_hasClass(element,...classNames)}catch(error){settingError("hasClass");element._hasClass=(...classNames)=>timonjs_hasClass(element,...classNames)}try{element.attr=(type,value)=>timonjs_attr(element,type,value)}catch(error){settingError("attr");element._attr=(type,value)=>timonjs_attr(element,type,value)}try{if(element.attribute)throw new Error;element.attribute=(type,value)=>timonjs_attribute(element,type,value)}catch(error){settingError("attribute");element._attribute=(type,value)=>timonjs_attribute(element,type,value)}try{element.data=(dataName,value)=>timonjs_data(element,dataName,value)}catch(error){settingError("data");element._data=(dataName,value)=>timonjs_data(element,dataName,value)}try{element.toggleText=(text1,text2)=>timonjs_toggleText(element,text1,text2)}catch(error){settingError("toggleText");element._toggleText=(text1,text2)=>timonjs_toggleText(element,text1,text2)}try{element.toggleHTML=(html1,html2)=>timonjs_toggleHTML(element,html1,html2)}catch(error){settingError("toggleHTML");element._toggleHTML=(html1,html2)=>timonjs_toggleHTML(element,html1,html2)}try{if(element.parent)throw new Error;element.parent=()=>timonjs_parent(element)}catch(error){settingError("parent");element._parent=()=>timonjs_parent(element)}try{element.hasChild=child=>hasChild(element,child)}catch(error){settingError("hasChild");element._hasChild=child=>hasChild(element,child)}try{element.hasChildWithId=id=>hasChildWithId(element,id)}catch(error){settingError("hasChildWithId");element._hasChildWithId=id=>hasChildWithId(element,id)}try{element.x=()=>timonjs_x(element)}catch(error){settingError("x");element._x=()=>timonjs_x(element)}try{element.y=()=>timonjs_y(element)}catch(error){settingError("y");element._y=()=>timonjs_y(element)}try{element.xy=()=>timonjs_xy(element)}catch(error){settingError("xy");element._xy=()=>timonjs_xy(element)}try{element.customId=id=>timonjs_customId(element,id)}catch(error){settingError("customId");element._customId=id=>timonjs_customId(element,id)}try{element.timonId=id=>timonjs_timonId(element,id)}catch(error){settingError("timonId");element._timonId=id=>timonjs_timonId(element,id)}try{if(element.append)throw new Error;element.append=(...nodes)=>timonjs_append(element,...nodes)}catch(error){settingError("append");element._append=(...nodes)=>timonjs_append(element,...nodes)}try{element.prepend=(...nodes)=>timonjs_prepend(element,...nodes)}catch(error){settingError("prepend");element._prepend=(...nodes)=>timonjs_prepend(element,...nodes)}try{element.childrenCount=()=>timonjs_childrenCount(element)}catch(error){settingError("childrenCount");element._childrenCount=()=>timonjs_childrenCount(element)}try{element.file=()=>timonjs_file(element)}catch(error){settingError("file");element._file=()=>timonjs_file(element)}try{if(element.files)throw new Error;element.files=()=>timonjs_files(element)}catch(error){settingError("files");element._files=()=>timonjs_files(element)}try{element.valIsEmpty=()=>timonjs_valIsEmpty(element)}catch(error){settingError("valIsEmpty");element._valIsEmpty=()=>timonjs_valIsEmpty(element)}try{element.vIE=()=>timonjs_vIE(element)}catch(error){settingError("vIE");element._vIE=()=>timonjs_vIE(element)}try{element.textIsEmpty=()=>timonjs_textIsEmpty(element)}catch(error){settingError("textIsEmpty");element._textIsEmpty=()=>timonjs_textIsEmpty(element)}try{element.htmlIsEmpty=()=>timonjs_htmlIsEmpty(element)}catch(error){settingError("htmlIsEmpty");element._htmlIsEmpty=()=>timonjs_htmlIsEmpty(element)}try{element.addAfter=(...nodes)=>timonjs_addAfter(element,...nodes)}catch(error){settingError("addAfter");element._addAfter=(...nodes)=>timonjs_addAfter(element,...nodes)}try{element.addBefore=(...nodes)=>timonjs_addBefore(element,...nodes)}catch(error){settingError("addBefore");element._addBefore=(...nodes)=>timonjs_addBefore(element,...nodes)}try{element.getImg=()=>timonjs_getImg(element)}catch(error){settingError("getImg");element._getImg=()=>timonjs_getImg(element)}try{element.getImgBase64=()=>timonjs_getImgBase64(element)}catch(error){settingError("getImgBase64");element._getImgBase64=()=>timonjs_getImgBase64(element)}try{element.imgBase=()=>timonjs_imgBase(element)}catch(error){settingError("imgBase");element._imgBase=()=>timonjs_imgBase(element)}try{element.fullscreen=()=>timonjs_fullscreen(element)}catch(error){settingError("fullscreen");element._fullscreen=()=>timonjs_fullscreen(element)}element.getElm=id=>getElm(id,element);element.getQuery=query=>getQuery(query,element);return element}function getQuery(query,caller=document){const elements=caller.querySelectorAll(query);if(elements.length===0){console.error(`There is no element with query ${query}`)}const settingError=name=>{if(DEBUG)console.log(`The function "${name}" is already declared for this element. The replaced function is named "_${name}".`)};try{elements.get=position=>elements[position]}catch(error){settingError("get");elements._get=position=>elements[position]}try{elements.on=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_on(elements[i],event,callback,...args)}}}catch(error){settingError("on");elements._on=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_on(elements[i],event,callback,...args)}}}try{elements.off=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_off(elements[i],event,callback,...args)}}}catch(error){settingError("off");elements._off=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_off(elements[i],event,callback,...args)}}}try{elements.click=(callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_click(elements[i],elements[i].click.bind(elements[i]),callback,...args)}}}catch(error){settingError("click");elements._click=(callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_click(elements[i],elements[i].click.bind(elements[i]),callback,...args)}}}try{elements.childrenOn=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_childrenOn(elements[i],event,callback,...args)}}}catch(error){settingError("childrenOn");elements._childrenOn=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_childrenOn(elements[i],event,callback,...args)}}}try{elements.childrenOff=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_childrenOff(elements[i],event,callback,...args)}}}catch(error){settingError("childrenOff");elements._childrenOff=(event,callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_childrenOff(elements[i],event,callback,...args)}}}try{elements.childrenClick=(callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_childrenClick(elements[i],callback,...args)}}}catch(error){settingError("childrenClick");elements._childrenClick=(callback,...args)=>{for(let i=0;i<elements.length;i++){timonjs_childrenClick(elements[i],callback,...args)}}}try{elements.css=(styles,value)=>{for(let i=0;i<elements.length;i++){timonjs_css(elements[i],styles,value)}}}catch(error){settingError("css");elements._css=(styles,value)=>{for(let i=0;i<elements.length;i++){timonjs_css(elements[i],styles,value)}}}try{elements.toggle=(type,type2)=>{for(let i=0;i<elements.length;i++){timonjs_toggle(elements[i],type,type2)}}}catch(error){settingError("toggle");elements._toggle=(type,type2)=>{for(let i=0;i<elements.length;i++){timonjs_toggle(elements[i],type,type2)}}}try{elements.hide=()=>{for(let i=0;i<elements.length;i++){timonjs_hide(elements[i])}}}catch(error){settingError("hide");elements._hide=()=>{for(let i=0;i<elements.length;i++){timonjs_hide(elements[i])}}}try{elements.show=type=>{for(let i=0;i<elements.length;i++){timonjs_show(elements[i],type)}}}catch(error){settingError("show");elements._show=type=>{for(let i=0;i<elements.length;i++){timonjs_show(elements[i],type)}}}try{elements.flex=()=>{for(let i=0;i<elements.length;i++){timonjs_flex(elements[i])}}}catch(error){settingError("flex");elements._flex=()=>{for(let i=0;i<elements.length;i++){timonjs_flex(elements[i])}}}try{elements.grid=()=>{for(let i=0;i<elements.length;i++){timonjs_grid(elements[i])}}}catch(error){settingError("grid");elements._grid=()=>{for(let i=0;i<elements.length;i++){timonjs_grid(elements[i])}}}try{elements.class=(className,replaceClass)=>{for(let i=0;i<elements.length;i++){timonjs_class(elements[i],className,replaceClass)}}}catch(error){settingError("class");elements._class=(className,replaceClass)=>{for(let i=0;i<elements.length;i++){timonjs_class(elements[i],className,replaceClass)}}}try{elements.addClass=(...classList)=>{for(let i=0;i<elements.length;i++){timonjs_addClass(elements[i],...classList)}}}catch(error){settingError("addClass");elements._addClass=(...classList)=>{for(let i=0;i<elements.length;i++){timonjs_addClass(elements[i],...classList)}}}try{elements.removeClass=(...classList)=>{for(let i=0;i<elements.length;i++){timonjs_removeClass(elements[i],...classList)}}}catch(error){settingError("removeClass");elements._removeClass=(...classList)=>{for(let i=0;i<elements.length;i++){timonjs_removeClass(elements[i],...classList)}}}try{elements.replaceClass=(replaceClass,setClass)=>{for(let i=0;i<elements.length;i++){timonjs_replaceClass(elements[i],replaceClass,setClass)}}}catch(error){settingError("replaceClass");elements._replaceClass=(replaceClass,setClass)=>{for(let i=0;i<elements.length;i++){timonjs_replaceClass(elements[i],replaceClass,setClass)}}}try{elements.toggleClass=(...classNames)=>{for(let i=0;i<elements.length;i++){timonjs_toggleClass(elements[i],...classNames)}}}catch(error){settingError("toggleClass");elements._toggleClass=(...classNames)=>{for(let i=0;i<elements.length;i++){timonjs_toggleClass(elements[i],...classNames)}}}try{elements.hasClass=(...classNames)=>{for(let i=0;i<elements.length;i++){timonjs_hasClass(elements[i],...classNames)}}}catch(error){settingError("hasClass");elements._hasClass=(...classNames)=>{for(let i=0;i<elements.length;i++){timonjs_hasClass(elements[i],...classNames)}}}try{if(elements.append)throw new Error;elements.append=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_append(elements[i],...nodes)}}}catch(error){settingError("append");elements._append=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_append(elements[i],...nodes)}}}try{elements.prepend=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_prepend(elements[i],...nodes)}}}catch(error){settingError("prepend");elements._prepend=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_prepend(elements[i],...nodes)}}}try{elements.addAfter=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_addAfter(elements[i],...nodes)}}}catch(error){settingError("addAfter");elements._addAfter=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_addAfter(elements[i],...nodes)}}}try{elements.addBefore=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_addBefore(elements[i],...nodes)}}}catch(error){settingError("addBefore");elements._addBefore=(...nodes)=>{for(let i=0;i<elements.length;i++){timonjs_addBefore(elements[i],...nodes)}}}for(let i=0;i<elements.length;i++){const element=elements[i];if(typeof element.timonId==="string"){continue}element.timonId=randomString(16);const nativeClick=element.click.bind(element);try{element.on=(event,callback,...args)=>timonjs_on(element,event,callback,...args)}catch(error){settingError("on");element._on=(event,callback,...args)=>timonjs_on(element,event,callback,...args)}try{element.off=(event,callback,...args)=>timonjs_off(element,event,callback,...args)}catch(error){settingError("off");element._off=(event,callback,...args)=>timonjs_off(element,event,callback,...args)}try{element.click=(callback,...args)=>timonjs_click(element,nativeClick,callback,...args)}catch(error){settingError("click");element._click=(callback,...args)=>timonjs_click(element,nativeClick,callback,...args)}try{element.childrenOn=(event,callback,...args)=>timonjs_childrenOn(element,event,callback,...args)}catch(error){settingError("childrenOn");element._childrenOn=(event,callback,...args)=>timonjs_childrenOn(element,event,callback,...args)}try{element.childrenOff=(event,callback,...args)=>timonjs_childrenOff(element,event,callback,...args)}catch(error){settingError("childrenOff");element._childrenOff=(event,callback,...args)=>timonjs_childrenOff(element,event,callback,...args)}try{element.childrenClick=(callback,...args)=>timonjs_childrenClick(element,callback,...args)}catch(error){settingError("childrenClick");element._childrenClick=(callback,...args)=>timonjs_childrenClick(element,callback,...args)}try{element.css=(styles,value)=>timonjs_css(element,styles,value)}catch(error){settingError("css");element._css=(styles,value)=>timonjs_css(element,styles,value)}try{element.toggle=(type,type2)=>timonjs_toggle(element,type,type2)}catch(error){settingError("toggle");element._toggle=(type,type2)=>timonjs_toggle(element,type,type2)}try{element.hide=()=>timonjs_hide(element)}catch(error){settingError("hide");element._hide=()=>timonjs_hide(element)}try{element.show=type=>timonjs_show(element,type)}catch(error){settingError("show");element._show=type=>timonjs_show(element,type)}try{element.flex=()=>timonjs_flex(element)}catch(error){settingError("flex");element._flex=()=>timonjs_flex(element)}try{element.grid=()=>timonjs_grid(element)}catch(error){settingError("grid");element._grid=()=>timonjs_grid(element)}try{element.rotate=degrees=>timonjs_rotate(element,degrees)}catch(error){settingError("rotate");element._rotate=degrees=>timonjs_rotate(element,degrees)}try{if(element.text)throw new Error;element.text=text=>timonjs_text(element,text)}catch(error){settingError("text");element._text=text=>timonjs_text(element,text)}try{element.html=html=>timonjs_html(element,html)}catch(error){settingError("html");element._html=html=>timonjs_html(element,html)}try{element.val=value=>timonjs_val(element,value)}catch(error){settingError("val");element._val=value=>timonjs_val(element,value)}try{element.class=(className,replaceClass)=>timonjs_class(element,className,replaceClass)}catch(error){settingError("class");element._class=(className,replaceClass)=>timonjs_class(element,className,replaceClass)}try{element.addClass=(...classList)=>timonjs_addClass(element,...classList)}catch(error){settingError("addClass");element._addClass=(...classList)=>timonjs_addClass(element,...classList)}try{element.removeClass=(...classList)=>timonjs_removeClass(element,...classList)}catch(error){settingError("removeClass");element._removeClass=(...classList)=>timonjs_removeClass(element,...classList)}try{element.replaceClass=(replaceClass,setClass)=>timonjs_replaceClass(element,replaceClass,setClass)}catch(error){settingError("replaceClass");element._replaceClass=(replaceClass,setClass)=>timonjs_replaceClass(element,replaceClass,setClass)}try{element.toggleClass=(...classNames)=>timonjs_toggleClass(element,...classNames)}catch(error){settingError("toggleClass");element._toggleClass=(...classNames)=>timonjs_toggleClass(element,...classNames)}try{element.hasClass=(...classNames)=>timonjs_hasClass(element,...classNames)}catch(error){settingError("hasClass");element._hasClass=(...classNames)=>timonjs_hasClass(element,...classNames)}try{element.attr=(type,value)=>timonjs_attr(element,type,value)}catch(error){settingError("attr");element._attr=(type,value)=>timonjs_attr(element,type,value)}try{if(element.attribute)throw new Error;element.attribute=(type,value)=>timonjs_attribute(element,type,value)}catch(error){settingError("attribute");element._attribute=(type,value)=>timonjs_attribute(element,type,value)}try{element.data=(dataName,value)=>timonjs_data(element,dataName,value)}catch(error){settingError("data");element._data=(dataName,value)=>timonjs_data(element,dataName,value)}try{element.toggleText=(text1,text2)=>timonjs_toggleText(element,text1,text2)}catch(error){settingError("toggleText");element._toggleText=(text1,text2)=>timonjs_toggleText(element,text1,text2)}try{element.toggleHTML=(html1,html2)=>timonjs_toggleHTML(element,html1,html2)}catch(error){settingError("toggleHTML");element._toggleHTML=(html1,html2)=>timonjs_toggleHTML(element,html1,html2)}try{if(element.parent)throw new Error;element.parent=()=>timonjs_parent(element)}catch(error){settingError("parent");element._parent=()=>timonjs_parent(element)}try{element.hasChild=child=>hasChild(element,child)}catch(error){settingError("hasChild");element._hasChild=child=>hasChild(element,child)}try{element.hasChildWithId=id=>hasChildWithId(element,id)}catch(error){settingError("hasChildWithId");element._hasChildWithId=id=>hasChildWithId(element,id)}try{element.x=()=>timonjs_x(element)}catch(error){settingError("x");element._x=()=>timonjs_x(element)}try{element.y=()=>timonjs_y(element)}catch(error){settingError("y");element._y=()=>timonjs_y(element)}try{element.xy=()=>timonjs_xy(element)}catch(error){settingError("xy");element._xy=()=>timonjs_xy(element)}try{element.customId=id=>timonjs_customId(element,id)}catch(error){settingError("customId");element._customId=id=>timonjs_customId(element,id)}try{element.timonId=id=>timonjs_timonId(element,id)}catch(error){settingError("timonId");element._timonId=id=>timonjs_timonId(element,id)}try{if(element.append)throw new Error;element.append=(...nodes)=>timonjs_append(element,...nodes)}catch(error){settingError("append");element._append=(...nodes)=>timonjs_append(element,...nodes)}try{element.prepend=(...nodes)=>timonjs_prepend(element,...nodes)}catch(error){settingError("prepend");element._prepend=(...nodes)=>timonjs_prepend(element,...nodes)}try{element.childrenCount=()=>timonjs_childrenCount(element)}catch(error){settingError("childrenCount");element._childrenCount=()=>timonjs_childrenCount(element)}try{element.file=()=>timonjs_file(element)}catch(error){settingError("file");element._file=()=>timonjs_file(element)}try{if(element.files)throw new Error;element.files=()=>timonjs_files(element)}catch(error){settingError("files");element._files=()=>timonjs_files(element)}try{element.valIsEmpty=()=>timonjs_valIsEmpty(element)}catch(error){settingError("valIsEmpty");element._valIsEmpty=()=>timonjs_valIsEmpty(element)}try{element.vIE=()=>timonjs_vIE(element)}catch(error){settingError("vIE");element._vIE=()=>timonjs_vIE(element)}try{element.textIsEmpty=()=>timonjs_textIsEmpty(element)}catch(error){settingError("textIsEmpty");element._textIsEmpty=()=>timonjs_textIsEmpty(element)}try{element.htmlIsEmpty=()=>timonjs_htmlIsEmpty(element)}catch(error){settingError("htmlIsEmpty");element._htmlIsEmpty=()=>timonjs_htmlIsEmpty(element)}try{element.addAfter=(...nodes)=>timonjs_addAfter(element,...nodes)}catch(error){settingError("addAfter");element._addAfter=(...nodes)=>timonjs_addAfter(element,...nodes)}try{element.addBefore=(...nodes)=>timonjs_addBefore(element,...nodes)}catch(error){settingError("addBefore");element._addBefore=(...nodes)=>timonjs_addBefore(element,...nodes)}try{element.getImg=()=>timonjs_getImg(element)}catch(error){settingError("getImg");element._getImg=()=>timonjs_getImg(element)}try{element.getImgBase64=()=>timonjs_getImgBase64(element)}catch(error){settingError("getImgBase64");element._getImgBase64=()=>timonjs_getImgBase64(element)}try{element.imgBase=()=>timonjs_imgBase(element)}catch(error){settingError("imgBase");element._imgBase=()=>timonjs_imgBase(element)}try{element.fullscreen=()=>timonjs_fullscreen(element)}catch(error){settingError("fullscreen");element._fullscreen=()=>timonjs_fullscreen(element)}element.getElm=id=>getElm(id,element);element.getQuery=query=>getQuery(query,element)}return elements}async function post(url,body){try{const response=await fetch(window.location.origin+url,{method:"POST",headers:{"Content-Type":"application/json"},mode:"cors",cache:"default",_REDirect:"follow",credentials:"same-origin",referrerPolicy:"no-referrer-when-downgrade",body:JSON.stringify(body)});return await response.json()}catch(error){console.error(error);throw error}}async function GETText(url){try{const response=await fetch(url);return await response.text()}catch(error){console.error(error);throw error}}async function GETJson(url){try{const response=await fetch(url);return await response.json()}catch(error){console.error(error);throw error}}function randomString(length){let result="";const char="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";for(let i=0;i<length;i++){const randomIndex=Math.floor(Math.random()*char.length);result+=char[randomIndex]}return result}function scrollToQuery(query){const element=document.querySelector(query);if(element){element.scrollIntoView({behavior:"smooth",block:"center"})}}function setCss(element,styles){const cssString=Object.entries(styles).map((([property,value])=>`${property}:${value}`)).join("; ");element.style.cssText=cssString}function getDevice(){const agent=navigator.userAgent;if(/(tablet|ipad|playbook|silk)|(android(?!.*mobi))/i.test(agent)){return"tablet"}else if(/Mobile|iP(hone|od)|Android|BlackBerry|IEMobile|Kindle|Silk-Accelerated|(hpw|web)OS|Opera M(obi|ini)/.test(agent)){return"mobile"}else{return"desktop"}}async function download(url,filename=url){try{const response=await fetch(url);const blob=await response.blob();const downloadUrl=window.URL.createObjectURL(blob);const anchor=document.createElement("a");anchor.href=downloadUrl;anchor.download=filename;document.body.appendChild(anchor);anchor.click();document.body.removeChild(anchor);window.URL.revokeObjectURL(downloadUrl)}catch(error){console.error("Error downloading file:",error);throw new Error("Error downloading file")}}function log(...message){console.log(...message)}function errorLog(...message){console.error(...message)}function warnLog(...message){console.warn(...message)}function on(element,event,callback,...args){element.addEventListener(event,callback,...args)}function onClick(element,callback,...args){element.addEventListener("click",callback,...args)}function timonjs_fieldCreator(message,time,...args){const field=document.createElement("p");const img=document.createElement("img");const span=document.createElement("span");const output=document.createElement("span");field.style.cssText=`display:block;position:fixed;bottom:5vh;left:50%;transform:translateX(-50%);max-width:70vw;margin:0;padding:20px;background-color:var(--${args[0]}, ${args[2]});opacity:1;box-sizing:border-box;border-radius:15px;font-size:20px;line-height:1;z-index:1000000;`;img.style.cssText=`height:1lh;aspect-ratio:1/1;object-fit:contain;object-position:center;margin-right:0.25em;`;if(args.length>3)img.style.cssText+=args[3];field.classList.add(args[0]);img.alt=args[1];img.src="https://cdn.jsdelivr.net/npm/timonjs/assets/alert.svg";output.innerText=message;field.append(img,span,output);document.querySelector("body").appendChild(field);setTimeout((()=>{if(typeof gsap==="undefined"){const style=document.createElement("link");style.rel="stylesheet";style.href="https://cdn.jsdelivr.net/npm/timonjs/assets/timonjs.min.css";document.querySelector("head").appendChild(style);field.style.animation=`timonjs-fadeout ${time}ms ease-in`}else{gsap.to(field,{opacity:0,display:"none",duration:time/1e3,ease:"power2.in"})}setTimeout((()=>field.remove()),time)}),time)}function errorField(message="Etwas hat nicht geklappt. Versuche es in einigen Sekunden erneut.",time=5e3){timonjs_fieldCreator(message,time,"error","Error","#d61c35")}function infoField(message,time=5e3){timonjs_fieldCreator(message,time,"info","Info","#4286bd","transform:rotate(180deg);")}function successField(message,time=5e3){timonjs_fieldCreator(message,time,"success","Info","#40b959","transform:rotate(180deg);")}function createElm(type,amount=1){const elements=[];for(let i=0;i<amount;i++){const temp=document.createElement(type);const id=randomString(32);temp.id=id;document.querySelector("head").appendChild(temp);elements.push(getElm(id));document.querySelector("head").removeChild(temp)}return elements.length===1?elements[0]:elements}function elementToJson(element){const json={tagName:element.tagName,attributes:Array.from(element.attributes).map((attr=>({name:attr.name,value:attr.value}))),children:Array.from(element.childNodes).map((child=>{if(child.nodeType===Node.TEXT_NODE){const content=child.textContent.trim();if(content!==""){json.children.push({nodeType:"text",content:child.textContent})}}else if(child.nodeType===Node.ELEMENT_NODE){json.children.push(elementToJson(child))}}))};return json}function jsonToElement(json){if(json.nodeType==="text"){return document.createTextNode(json.content)}const element=document.createElement(json.tagName);json.attributes.forEach((attr=>element.setAttribute(attr.name,attr.value)));json.children.forEach((child=>{element.append(jsonToElement(child))}));return element}function ready(callback,...options){addEventListener("DOMContentLoaded",callback,...options)}const ORIGIN=typeof window!=="undefined"?window.location.origin:undefined;const BREAKPOINTS={MOBILE:{SMALL:260,BIG:575},TABLET:{SMALL:750,BIG:1e3},DESKTOP:{SMALL:1200,BIG:1700}};export default{timonjs_setDebugMode:timonjs_setDebugMode,timonjs_message:timonjs_message,toBase64:toBase64,toBase64Max:toBase64Max,toDateString:toDateString,getElm:getElm,getQuery:getQuery,getDevice:getDevice,setCss:setCss,on:on,onClick:onClick,log:log,errorLog:errorLog,warnLog:warnLog,randomString:randomString,post:post,GETJson:GETJson,GETText:GETText,download:download,scrollToQuery:scrollToQuery,successField:successField,infoField:infoField,errorField:errorField,createElm:createElm,elementToJson:elementToJson,jsonToElement:jsonToElement,ready:ready,ORIGIN:ORIGIN,BREAKPOINTS:BREAKPOINTS};export{timonjs_setDebugMode,timonjs_message,toBase64,toBase64Max,toDateString,getElm,getQuery,getDevice,setCss,on,onClick,log,errorLog,warnLog,randomString,post,GETJson,GETText,download,scrollToQuery,successField,infoField,errorField,createElm,elementToJson,jsonToElement,ready,ORIGIN,BREAKPOINTS};